#include <iostream>     // dclarer l'entre-sortie standard
#include <set>          // pour dfinir la class gnrique multiset
using namespace std;

template <typename T>
ostream& operator << ( ostream& out, const multiset<T>& ens )
{
  out << "{ ";
  typename multiset<T>::const_iterator it;
  for ( it= ens.begin(); it!=ens.end(); ++it )
    out << *it << " ";
  out << "}";
  return out;
}

int main()
{
  cout << "\nBienvenue aux ensembles ! On teste ici la classe multiset.\n"
       << "Entrez un entier positif pour l'ajouter, ngatif pour effacer, "
       << "0 pour terminer." << endl;
  multiset<int> ensemble;
  for (;;)
    {
      cout << "ensemble = " << ensemble << endl;
      cout << "Entrez un entier svp : ";
      int element; 
      cin >> element;
      if ( element == 0 ) break;
      if ( element > 0 ) 
	ensemble.insert( element );
      else 
	ensemble.erase( -element );
    };
  for (;;)
    {
      cout << "Entrez un nombre  chercher svp : ";
      int element, count; 
      cin >> element;
      if ( element == 0 ) break;
      count= ensemble.count( element );
      if ( count > 0 ) 
	cout << "L'lment " << element << " appartient  l'ensemble (" << count << " fois).\n";
      else
	cout << "L'lment " << element << " n'appartient pas  l'ensemble.\n";
    };
  cout << "Au revoir.\n" << endl;
}
