#include <iostream>     // dclarer l'entre-sortie standard
#include <set>          // pour dfinir la class gnrique set
using namespace std;

template <typename T>
ostream& operator << ( ostream& out, const set<T>& ens )
{
  out << "{ ";
  typename set<T>::const_iterator it;
  for ( it= ens.begin(); it!=ens.end(); ++it )
    out << *it << " ";
  out << "}";
  return out;
}

int main()
{
  cout << "\nBienvenue aux ensembles ! On teste ici la classe set.\n"
       << "Entrez un entier positif pour l'ajouter, ngatif pour effacer, "
       << "0 pour terminer." << endl;
  set<int> ensemble;
  for(;;)
    {
      cout << "ensemble = " << ensemble << endl;
      cout << "Entrez un entier svp : ";
      int element; 
      cin >> element;
      if ( element == 0 ) break;
      if ( element  > 0 ) ensemble.insert( element );
      else                ensemble.erase( -element );
    }
  for(;;)
    {
      cout << "Entrez un nombre  chercher svp : ";
      int element; 
      cin >> element;
      if ( element == 0 ) break;
      if ( ensemble.count( element ) > 0 ) 
	cout << "L'lment " << element << " appartient  l'ensemble.\n";
      else
	cout << "L'lment " << element << " n'appartient pas  l'ensemble.\n";
    }
  cout << "Au revoir.\n" << endl;
}
