#include <iostream>     // pour dclarer l'entre-sortie standard
#include <algorithm>    // pour dfinir les fonctions de tri et de recherche
#include <vector>       // pour dfinir la class gnrique vector
#include <cstdlib>      // pour dclarer la fonction random()
using namespace std;

template <typename T>
ostream& operator << ( ostream& out, const vector<T>& vec )
{
  out << "( ";
  for ( size_t i=0; i<vec.size(); ++i ) out << vec[i] << " ";
  out << ")";
  return out;
}

void aleatoire( vector<int>& vec  )
{ 
  for ( size_t i=0; i<vec.size(); ++i ) vec[i]= random() % vec.size();
}

int main()
{
  cout << "\nBienvenue aux vecteurs alatoires !" << endl;
  cout << "Entrez la longueur svp : ";
  int longueur; 
  cin >> longueur;
  vector<int> vec(longueur);
  aleatoire(vec);
  cout << "\nvoici un vecteur alatoire :  " << vec << endl;
  sort( vec.begin(), vec.end() );
  cout << "\naprs un tri rapide :         " << vec << endl;  
  random_shuffle( vec.begin(), vec.end() );
  cout << "\naprs une mlange alatoire : " << vec << endl;  
  stable_sort( vec.begin(), vec.end() );
  cout << "\naprs un tri fusion :         " << vec << endl;  
  cout << "\nEntrez un nombre  chercher svp : ";
  int element; 
  cin >> element;
  bool trouve= binary_search( vec.begin(), vec.end(), element );
  if ( trouve ) cout << "L'lment " << element << " appartient  la liste.\n";
  else cout << "L'lment " << element << " n'appartient pas  la liste.\n";
  cout << "Au revoir.\n" << endl;
}
