/*=======================================================================*\
 * permut-v01.cc : implmentation minimaliste de permutations
 * Copyright (C) 2003-2005 by Michael Eisermann, all rights reserved
 * Institut Fourier, Universit Joseph Fourier, Grenoble, France
\*=======================================================================*/

#include <vector>
using namespace std;

class Permut
{
public:
  typedef short int Point;      // type des points  permuter
  vector<Point> leVecteur;      // pour stocker la permutation
  void raccourcir( void );      // supprimer de points fixes 
};

void Permut::raccourcir( void )
{
  Point p= leVecteur.size()-1;
  while ( p >= 0 && leVecteur[p] == p ) --p;
  leVecteur.resize(p+1);
};
