//=======================================================================
// instable-naif.cc : itration de l'application  x -> 4x(1-x)
// Copyright (C) 2004-2007 Michael Eisermann, all rights reserved
// Institut Fourier, Universit Joseph Fourier, Grenoble, France
//=======================================================================
 
#include <iostream>
#include <iomanip>
#include <cmath>
using namespace std;

int main()
{
  cout << "\nBonjour et bienvenue ! Ce programme itre la fonction f(x) = 4x(1-x).\n"
       << "Elle envoie l'intervalle [0,1] sur [0,1] et admet pour points fixes\n"
       << "0 et 3/4, tous les deux rpulsifs. Afin d'illustrer le caractre instable,\n"
       << "nous utilisons le type double (mantisse de 53 bits soit 16 dcimales environ).\n" << endl;
  
  cout << "Veuillez entrer deux nombres (proches) x,y dans l'intervalle [0,1]\n"
       << "(Par exemple x=0.5 exact et y=0.4999999 une valeur approche\n"
       << "ou bien x=0.1 et y=0.10000000001 ou des exemples similaires) :" << endl; 
  double x,y;
  cout << "x = ";
  cin >> x;
  cout << "y = ";
  cin >> y;
  if ( x < 0.0 || x > 1.0 || y < 0.0 || y > 1.0 ) exit(0);

  cout << "Combien d'itrations dsirez-vous ? ";
  int iterations;
  cin >> iterations;
  
  cout.precision(16);
  cout.setf( ios::fixed );
  for( int k=0; k<=iterations; ++k )
    {
      cout << "k=" << setw(3) << k << "   x=" << x << "   y=" << y 
	   << "   cart=" << fabs(x-y) << endl;
      x= 4*x*(1-x);
      y= 4*y*(1-y);
    };
  cout << "\nAu revoir et  bientt.\n" << endl;
}
