#include <iostream>     // dclarer l'entre-sortie standard
#include <fstream>      // manipuler les flots associs aux fichiers
using namespace std;    // accs direct aux fonctions standard

int main()
{
  clog << "J'ouvre le fichier \"lecture.txt\" pour lecture ... ";
  ifstream entree("lecture.txt");   // ifstream = input file stream
  if ( !entree ) { clog << "echec." << endl; return 1; };
  clog << "ok." << endl;
  
  clog << "J'ouvre le fichier \"ecriture.txt\" pour criture ... ";  
  ofstream sortie("ecriture.txt");  // ofstream = output file stream
  if ( !sortie ) { clog << "echec." << endl; return 1; }
  clog << "ok." << endl;
  
  int nombre_in, nombre_out;
  while( !entree.eof() )
    {
      entree >> nombre_in;
      if( entree.eof() ) break;
      nombre_out= abs(nombre_in);
      sortie << nombre_out << " ";
      clog << "J'ai lu " << nombre_in << " --> j'ai crit " << nombre_out << endl;
    }
  clog << "Je ferme les fichiers \"lecture.txt\" et \"ecriture.txt\"." << endl;
  entree.close(); sortie.close();
}
