#include <iostream>              // dclarer l'entre-sortie standard
#include <vector>                // dfinir la classe gnrique vector
using namespace std;             // accs direct aux fonctions standard

ostream& operator << ( ostream& out, const vector<int>& vec )
{
  out << "( ";                          // parenthse ouvrante pour faire joli
  for ( size_t i=0; i<vec.size(); ++i ) // boucle parcourant les indices
    out << vec[i] << " ";               // affichage de la valeur vec[i]
  out << ")";                           // parenthse fermante pour faire joli
  return out;                           // on rend le flot comme il se doit
}

int main()
{
  cout << "\nVoici quelques oprations sur des vecteurs:\n" << endl;
  vector<int> mon_vecteur(5);    // dfinir un vecteur de longueur 5
  cout << "initialisation(5) : " << mon_vecteur << endl;
  mon_vecteur.resize(20,99);     // rallonger le vecteur en remplissant par 99
  cout << "adaptation(20,99) : " << mon_vecteur << endl;
  mon_vecteur.resize(10);        // raccourcir le vecteur  la longueur 10
  cout << "adaptation(10) :    " << mon_vecteur << endl;
  for ( int i=0; i<10; ++i )     // boucle parcourant les indices du vecteur
    mon_vecteur[i]= 10+i;        // affecter une valeur  la place indexe i
  cout << "affectation :       " << mon_vecteur << endl;
  vector<int> une_copie;         // dfinir un deuxime vecteur (encore vide)
  cout << "un vecteur vide :   " << une_copie << endl;  
  une_copie= mon_vecteur;        // affectation (par recopiage des lments)
  cout << "copie du vecteur :  " << une_copie << endl << endl;  
  mon_vecteur.push_back(90);     // rajouter la valeur 90  la fin
  cout << "prolongation :      " << mon_vecteur << endl;
  mon_vecteur.pop_back();        // raccourcir en effaant la dernire place
  cout << "troncature :        " << mon_vecteur << endl;
  mon_vecteur.clear();           // effacer le vecteur tout entier
  cout << "dltion complte : " << mon_vecteur << endl << endl;
  cout << "copie retenue :     " << une_copie << endl << endl;
}
