//=======================================================================
// fraction.cc : corps des fractions d'un anneau de Bezout
// Copyright (C) 2003-2007 Michael Eisermann, all rights reserved
// Institut Fourier, Universit Joseph Fourier, Grenoble, France
//
// Ce programme illustre l'usage de la classe gnrique Fraction<A>
// qui modlise le corps de fractions d'un anneau A (suppos avec pgcd).
//=======================================================================

#include <iostream>
#include "integer.cc"
#include "fraction.hh"
using namespace std;

int main()
{
  cout << "Bienvenue au corps de fractions !\n"
       << "Entrez deux lments a,b sous la forme  num/den  svp : ";
  Fraction<Integer> a,b;
  cin >> a >> b;
  cout << "a   = " << a << endl;
  cout << "b   = " << b << endl;
  cout << "a+b = " << a+b << endl;
  cout << "a-b = " << a-b << endl;
  cout << "a*b = " << a*b << endl;
  cout << "a/b = " << a/b << endl;
}
