//=======================================================================
// polynome-test.cc : implmentation basique de polynomes complexes
// Copyright (C) 2005-2007 by Michael Eisermann, all rights reserved
// Institut Fourier, Universit Joseph Fourier, Grenoble, France
//=======================================================================

#include <iostream>  // entre-sortie via des flots 
#include <fstream>   // fonctions pour lire et crire des fichiers
using namespace std;

typedef long double Flo; // nombres flottants standards
#include "polynome.cc"   // classe modlisant les polynomes complexes

int main()
{
  cout << "Bonjour et bienvenue aux polynmes !" << endl;
  
  // Ouvrir le fichier, afficher un message en cas d'erreur 
  ifstream in( "polynome.txt" );
  if ( !in ) 
    {
      cout << "Je ne peux pas lire le fichier \"polynome.txt\"." << endl
	   << "Veuillez rendre les polynmes accessibles  cet endroit." << endl;
      exit(0);
    }
  
  // Lire deux polynmes du fichier
  Polynome p, q;
  in >> p >> q;
  in.close();
  
  // Affichage des polynmes
  cout << "J'ai lu un premier polynme de degr " << degre(p) << endl << p << endl
       << "puis un deuxime polynme de degr " << degre(q) << endl << q << endl
       << "somme :" << endl << p+q << endl
       << "produit :" << endl << p*q << endl;
  
  cout << "Au revoir et  bientt." << endl;
}
